diff --git a/jerry-core/vm/vm.c b/jerry-core/vm/vm.c
index dab16304e7..bba6f06613 100644
--- a/jerry-core/vm/vm.c
+++ b/jerry-core/vm/vm.c
@@ -2008,6 +2008,7 @@ vm_loop (vm_frame_ctx_t *frame_ctx_p) /**< frame context */
 
             if (ECMA_IS_VALUE_ERROR (result))
             {
+              ecma_deref_object (array_p);
               goto error;
             }
 
@@ -2021,6 +2022,7 @@ vm_loop (vm_frame_ctx_t *frame_ctx_p) /**< frame context */
 
             if (ECMA_IS_VALUE_ERROR (value))
             {
+              ecma_deref_object (array_p);
               result = value;
               goto error;
             }
diff --git a/tests/jerry/fail/regression-test-issue-3437.js b/tests/jerry/fail/regression-test-issue-3437.js
new file mode 100644
index 0000000000..298e6dbba3
--- /dev/null
+++ b/tests/jerry/fail/regression-test-issue-3437.js
@@ -0,0 +1,15 @@
+// Copyright JS Foundation and other contributors, http://js.foundation
+//
+// Licensed under the Apache License, Version 2.0 (the "License");
+// you may not use this file except in compliance with the License.
+// You may obtain a copy of the License at
+//
+//     http://www.apache.org/licenses/LICENSE-2.0
+//
+// Unless required by applicable law or agreed to in writing, software
+// distributed under the License is distributed on an "AS IS" BASIS
+// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+// See the License for the specific language governing permissions and
+// limitations under the License.
+
+[...RegExp.prototype.compile] = ([]);
